/*
* Title: WebHamsters
* Description: Javascript library to add multi-threading support to javascript by exploiting concurrent web workers
* Author: Austin K. Smith
* Contact: austin@asmithdev.com
* Copyright: 2015 Austin K. Smith - austin@asmithdev.com
* License: Artistic License 2.0
*/
var hamsters={version:"3.1",debug:false,cache:false,maxThreads:Math.ceil((navigator.hardwareConcurrency||3)*1.25),tools:{},wheel:{legacy:false,queue:{running:[],pending:[]},tasks:[],errors:[],uri:null}};self.wakeUp=function(){self.isIE=function(version){return(new RegExp("msie"+(!isNaN(version)?("\\s"+version):""),"i").test(navigator.userAgent))};self.isLegacy=function(callback){try{if(!window.Worker||navigator.userAgent.indexOf("Kindle/3.0")!==-1||navigator.userAgent.indexOf("Mobile/8F190")!==-1||navigator.userAgent.indexOf("IEMobile")!==-1||self.isIE(10)){hamsters.wheel.legacy=true}}catch(e){}callback(hamsters.wheel.legacy)};hamsters.tools.checkErrors=function(){var errors=hamsters.wheel.errors||[];return{msg:"There are currently "+errors.length+" errors captured in the wheel",total:errors.length,errors:errors}};hamsters.tools.splitArray=function(array,n){var i=0;var tasks=[];var size=Math.ceil(array.length/n);while(i<array.length){if(array.slice){tasks.push(array.slice(i,i+=size))}else{tasks.push(array.subarray(i,i+=size))}}return tasks};hamsters.tools.randomArray=function(count,callback){if(!count||!callback){hamsters.wheel.errors.push({msg:"Unable to generate random array, missing required params"});return}var params={count:count};hamsters.run(params,function(){var total=params.count;var i=0;while(i<total){rtn.data[rtn.data.length]=Math.round(Math.random()*(100-1)+1);i+=1}},function(output){callback(output)},1,false,null,false)};hamsters.wheel.checkCache=function(hash,dataType){var item,rtn;var i=0;var len=sessionStorage.length;for(i;i<len;i+=1){item=JSON.parse(sessionStorage[i]);if(item&&item.id===hash&&item.dT===dataType){rtn=item.oP;if(dataType!=="na"&&!hamsters.wheel.legacy){rtn=hamsters.wheel.processDataType(dataType,item.oP)}return rtn}}};hamsters.wheel.memoize=function(fn,inputArray,output,dataType){var hash=hamsters.wheel.hashResult({func:fn,dT:dataType,input:inputArray});if(hamsters.wheel.checkCache(hash,dataType)){return}try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({id:hash,dT:dataType,oP:output}))}catch(eve){if(eve.name==="QuotaExceededError"){sessionStorage.clear();try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({id:hash,dT:dataType,oP:output}))}catch(e){return}}}};hamsters.wheel.compareArrays=function(array1,array2){if(array1.length!==array2.length){return false}return array1.every(function(el,i){return(el===array2[i])})};self.populateElements=function(){if(!hamsters.wheel.uri){var blob=self.createBlob("("+String(self.giveHamsterWork())+"());");hamsters.wheel.uri=window.URL.createObjectURL(blob)}};self.giveHamsterWork=function(){var work=function(){var params,output;var respond=function(rtn,msg){if(params.dataType){output=processDataType(params.dataType,rtn.data);rtn.data=output.buffer;rtn.dataType=params.dataType;self.postMessage({results:rtn||null,msg:msg||""},[output.buffer])}else{self.postMessage({results:rtn||null,msg:msg||""})}};var processDataType=function(dataType,buffer){if(dataType==="uint32"){return new Uint32Array(buffer)}if(dataType==="uint16"){return new Uint16Array(buffer)}if(dataType==="uint8"){return new Uint8Array(buffer)}if(dataType==="uint8clamped"){return new Uint8ClampedArray(buffer)}if(dataType==="int32"){return new Int32Array(buffer)}if(dataType==="int16"){return new Int16Array(buffer)}if(dataType==="int8"){return new Int8Array(buffer)}if(dataType==="float32"){return new Float32Array(buffer)}if(dataType==="float64"){return new Float64Array(buffer)}return buffer};self.onmessage=function(e){var rtn={success:true,data:[]};params=e.data;if(typeof params==="string"){params=JSON.parse(e.data)}if(params.dataType&&typeof params.array==="object"){params.array=processDataType(params.dataType,params.array)}var fn=eval("("+params.fn+")");if(fn){fn();respond(rtn)}else{rtn.success=false;rtn.error="Missing function";rtn.msg="Error encounted check errors for details";respond(rtn)}}};return work};hamsters.wheel.sort=function(arr,order){if(order==="desc"){return Array.prototype.sort.call(arr,function(a,b){return b-a})}if(order==="asc"){return Array.prototype.sort.call(arr,function(a,b){return a-b})}if(order==="ascAlpha"){return arr.sort()}if(order==="descAlpha"){return arr.reverse()}};hamsters.run=function(params,fn,callback,workers,aggregate,dataType,memoize,order){if(!params||!fn){return"Error processing for loop, missing params or function"}workers=workers||1;var task=hamsters.wheel.newTask(hamsters.wheel.tasks.length,workers,order,dataType,fn,callback);if(dataType){dataType=dataType.toLowerCase()}if(hamsters.cache&&params.array&&params.array.length!==0){memoize=memoize||true;var hash=hamsters.wheel.hashResult({func:fn,dT:dataType||"na",input:params.array});var result=hamsters.wheel.checkCache(hash,dataType);if(result){setTimeout(function(){callback(result);hamsters.wheel.tasks[task.id]=null},4);return}}var key,hamsterfood={};for(key in params){if(params.hasOwnProperty(key)&&key!=="array"){hamsterfood[key]=params[key]}}hamsterfood.fn=fn.toString();hamsterfood.dataType=dataType;var workArray=params.array||null;if(params.array&&task.threads!==1){workArray=hamsters.tools.splitArray(params.array,task.threads)}var i=0;while(i<task.threads){if(workArray&&task.threads!==1){hamsters.wheel.newWheel(workArray[i],hamsterfood,aggregate,callback,task,i,null,memoize)}else{hamsters.wheel.newWheel(workArray,hamsterfood,aggregate,callback,task,i,null,memoize)}i+=1}};hamsters.wheel.newTask=function(taskid,workers,order,dataType,fn,cb){var task={id:taskid,workers:[],count:0,threads:workers,input:[],dataType:dataType||null,fn:fn||null,output:[],order:order||null,callback:cb};hamsters.wheel.tasks.push(task);return task};hamsters.wheel.trackInput=function(task,inputArray,thread,taskid,hamsterfood){task.input.push({input:inputArray,workerid:thread,taskid:taskid,params:hamsterfood,start:new Date().getTime()})};hamsters.wheel.poolThread=function(queue,inputArray,hamsterfood,threadid,cb,task,agg,memoize){queue.pending.push({memoize:memoize,input:inputArray,params:hamsterfood,workerid:threadid,callback:cb,task:task,aggregate:agg})};hamsters.wheel.trackThread=function(task,queue,thread){task.workers[task.workers.length]=thread;queue.running[queue.running.length]=thread};hamsters.wheel.legacyProcessor=function(food,inputArray,callback){setTimeout(function(){var params=food;var rtn={success:true,data:[]};var respond=function(rtn){callback(rtn)};params.array=inputArray;var fn=eval("("+params.fn+")");if(fn){fn();respond(rtn)}else{rtn.success=false;rtn.error="Missing function";rtn.msg="Error encounted check errors for details";respond(rtn)}},4)};hamsters.wheel.createHamster=function(){return new Worker(hamsters.wheel.uri)};self.createBlob=function(textContent){if(Blob){return new Blob([textContent],{type:"application/javascript"})}var BlobBuilder=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder;if(BlobBuilder){var blob=new BlobBuilder();blob.append([textContent],{type:"application/javascript"});blob=blob.getBlob();return blob}};hamsters.tools.aggregate=function(input,dataType){if(!dataType){return input.reduce(function(a,b){return a.concat(b)})}var i=0;var len=input.length;var bufferLength=0;for(i;i<len;i+=1){bufferLength+=input[i].length}var output=hamsters.wheel.processDataType(dataType,bufferLength);var offset=0;for(i=0;i<len;i+=1){output.set(input[i],offset);offset+=input[i].length}return output};hamsters.wheel.getOutput=function(output,aggregate,dataType){if(aggregate&&output.length<=20){return hamsters.tools.aggregate(output,dataType)}return output};hamsters.wheel.processQueue=function(hamster){var item=hamsters.wheel.queue.pending.shift();if(item){hamsters.wheel.newWheel(item.input,item.params,item.aggregate,item.callback,item.task,item.workerid,hamster,item.memoize)}};hamsters.wheel.terminateHamster=function(dataBlob){if(!dataBlob){return}if(dataBlob.close){dataBlob.close()}else{if(dataBlob.msClose){dataBlob.msClose()}else{if(dataBlob.slice){dataBlob=dataBlob.slice(0,0)}}}};hamsters.wheel.trainHamster=function(id,aggregate,callback,task,workerid,hamster,memoize){hamster.onmessage=function(e){if(hamsters.wheel.queue.pending.length===0){hamster.terminate()}hamsters.wheel.queue.running.splice(hamsters.wheel.queue.running.indexOf(id),1);task.workers.splice(task.workers.indexOf(workerid),1);var results=e.data.results;if(results.dataType){results.data=hamsters.wheel.processDataType(results.dataType,results.data)}task.output[workerid]=results.data;if(task.workers.length===0&&task.count===task.threads){if(hamsters.debug){console.info("Execution Complete! Elapsed: "+((e.timeStamp-task.input[0].start)/1000)+"s")}if(task.order){callback(hamsters.wheel.sort(hamsters.wheel.getOutput(task.output,aggregate,results.dataType),task.order))}else{callback(hamsters.wheel.getOutput(task.output,aggregate,results.dataType))}hamsters.wheel.tasks[task.id]=null;if(hamsters.cache&&memoize){var inputArray=task.input[0].input;var output=hamsters.wheel.getOutput(task.output,aggregate,results.dataType);if(output.length>0&&!results.dataType){setTimeout(function(){hamsters.wheel.memoize(task.fn,inputArray,output,"na")},4)}else{if(output.length>0&&results.dataType){setTimeout(function(){hamsters.wheel.memoize(task.fn,inputArray,hamsters.wheel.normalizeArray(output),results.dataType)},4)}}}}else{if(hamsters.debug==="verbose"){console.info("Hamster #"+id+" finished @ "+e.timeStamp)}}if(hamsters.wheel.queue.pending.length!==0){hamsters.wheel.processQueue(hamster)}};hamster.onerror=function(e){hamster.terminate();var err="Error Hamster #"+id+": Line "+e.lineno+" in "+e.filename+": "+e.message;hamsters.wheel.errors=hamsters.wheel.errors.concat({msg:err});console.error(err)}};hamsters.wheel.normalizeArray=function(input){var arr=[];var n=0;var len=input.length;for(n;n<len;n+=1){arr.push(input[n])}return arr};hamsters.wheel.processDataType=function(dataType,buffer){if(dataType==="uint32"){return new Uint32Array(buffer)}if(dataType==="uint16"){return new Uint16Array(buffer)}if(dataType==="uint8"){return new Uint8Array(buffer)}if(dataType==="uint8clamped"){return new Uint8ClampedArray(buffer)}if(dataType==="int32"){return new Int32Array(buffer)}if(dataType==="int16"){return new Int16Array(buffer)}if(dataType==="int8"){return new Int8Array(buffer)}if(dataType==="float32"){return new Float32Array(buffer)}if(dataType==="float64"){return new Float64Array(buffer)}return buffer};hamsters.wheel.generateHash=function(string){string=String(string);var hash=0;var i=string.length-1;for(i;i>=0;i--){hash+=(((hash<<5)-hash)+string.charCodeAt(i))&4294967295}return hash};hamsters.wheel.hashResult=function(obj){var result=0;for(var key in obj){if(obj.hasOwnProperty(key)){if(typeof obj[key]==="object"&&obj[key].length&&!obj[key].slice){result+=hamsters.wheel.generateHash(key+String(hamsters.wheel.normalizeArray(obj[key])))}else{result+=hamsters.wheel.generateHash(key+obj[key])}}}return result};hamsters.wheel.feedHamster=function(hamster,food,inputArray){if(inputArray&&food.dataType){food.array=hamsters.wheel.processDataType(food.dataType,inputArray);var buffer=food.array.buffer;food.array=buffer;hamster.postMessage(food,[buffer])}else{if(inputArray){food.array=inputArray;hamster.postMessage(food)}else{hamster.postMessage(food)}}};self.isLegacy(function(legacy){if(legacy){hamsters.wheel.newWheel=function(inputArray,hamsterfood,aggregate,callback,task,threadid,hamster,memoize){var debug=hamsters.debug;hamsters.wheel.legacyProcessor(hamsterfood,inputArray,function(output){task.count+=1;task.output[threadid]=output.data;if(task.count===task.threads){var rtn=hamsters.wheel.getOutput(task.output,aggregate,output.dataType);if(debug){console.info("Execution Complete! Elapsed: "+((new Date().getTime()-task.input[0].start)/1000)+"s")}callback(rtn);hamsters.wheel.tasks[task.id]=null;if(hamsters.cache&&memoize!==false){if(output.data.length>0&&!output.dataType){setTimeout(function(){hamsters.wheel.memoize(task.fn,task.input,output.data,"na")},4)}else{if(output.data.length>0&&output.dataType){setTimeout(function(){hamsters.wheel.memoize(task.fn,task.input,hamsters.wheel.normalizeArray(output.data),output.dataType)},4)}}}}});return}}else{hamsters.wheel.newWheel=function(inputArray,hamsterfood,aggregate,callback,task,threadid,hamster,memoize){if(hamsters.maxThreads&&hamsters.maxThreads<=hamsters.wheel.queue.running.length){hamsters.wheel.poolThread(hamsters.wheel.queue,inputArray,hamsterfood,threadid,callback,task,aggregate,memoize);return}var thread=(threadid||task.count);var debug=hamsters.debug;if(debug||memoize){hamsters.wheel.trackInput(task,inputArray,thread,task.id,hamsterfood);if(debug==="verbose"){console.info("Spawning Hamster #"+thread+" @ "+new Date().getTime())}}hamsters.wheel.trackThread(task,hamsters.wheel.queue,thread);if(!hamster){hamster=hamsters.wheel.createHamster()}hamsters.wheel.trainHamster(thread,aggregate,callback,task,thread,hamster,memoize);hamsters.wheel.feedHamster(hamster,hamsterfood,inputArray);task.count+=1};self.populateElements()}})};self.wakeUp();